## org.biojava.bio.structure.server
Class MMCIFFileInstallation

    java.lang.Object
      org.biojava.bio.structure.server.MMCIFFileInstallation

All Implemented Interfaces:
  PDBInstallation

    public class MMCIFFileInstallation

extends Object
implements PDBInstallation

Field Summary
`static Logger` `logger`

Constructor Summary
`MMCIFFileInstallation(File filePath)`

Method Summary
`void` `addPDBFilter(PDBFilter filter)` add a filter for PDB files.
`void` `clearFilters()` remove all filters, next time getAll is called, it will return all available PDBs
`File` `downloadCIF(String pdbId)`
`List<PDBHeader>` `getAll()` get all PDBHeaders that pass the added Filters, if no filters have been added returns all available PDBs
`PDBHeader` `getPDBHeader(String pdbId)` get the PDB header for a single protein structure
`Structure` `getStructure(String pdbId)` request a structure by its PDB identifier
`boolean` `hasNext()` return if the iteration over all structures will return another structure
`boolean` `isAutoFetch()` should the parser to fetch missing mmCif files from the RCSB FTP server automatically? default is false
`Structure` `next()` iterate over all structures in this Installation that pass the provided filters and return the next one in the list.
`void` `setAutoFetch(boolean autoFetch)` tell the parser to fetch missing mmCif files from the RCSB FTP server automatically.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    public static final Logger logger

Constructor Detail

### MMCIFFileInstallation

    public MMCIFFileInstallation(File filePath)

Method Detail

### isAutoFetch

    public boolean isAutoFetch()

  should the parser to fetch missing mmCif files from the RCSB FTP server automatically? default is false

  Returns:
    flag

### setAutoFetch

    public void setAutoFetch(boolean autoFetch)

  tell the parser to fetch missing mmCif files from the RCSB FTP server automatically. default is false. If true, new PDB files will be automatically stored in the Path and gzip compressed.

  Parameters:
    `autoFetch` -

### downloadCIF

    public File downloadCIF(String pdbId)

### addPDBFilter

    public void addPDBFilter(PDBFilter filter)

  Description copied from interface: `PDBInstallation`
  add a filter for PDB files. THis can be used to request, e.g. all X-ray structures, or all structures with a given resolution, all proteins with a certain function, etc.

  Specified by:
    `addPDBFilter` in interface `PDBInstallation`
  Parameters:
    `filter` - the filter to apply when getAll is being called.
  See Also:
    `PDBInstallation.getAll()`

### clearFilters

    public void clearFilters()

  Description copied from interface: `PDBInstallation`
  remove all filters, next time getAll is called, it will return all available PDBs

  Specified by:
    `clearFilters` in interface `PDBInstallation`

### getAll

    public List<PDBHeader> getAll()

  Description copied from interface: `PDBInstallation`
  get all PDBHeaders that pass the added Filters, if no filters have been added returns all available PDBs

  Specified by:
    `getAll` in interface `PDBInstallation`
  Returns:
    a list of PDBHeader objects

### getPDBHeader

    public PDBHeader getPDBHeader(String pdbId)

  Description copied from interface: `PDBInstallation`
  get the PDB header for a single protein structure

  Specified by:
    `getPDBHeader` in interface `PDBInstallation`
  Returns:
    the PDB header object

### getStructure

    public Structure getStructure(String pdbId)

  Description copied from interface: `PDBInstallation`
  request a structure by its PDB identifier

  Specified by:
    `getStructure` in interface `PDBInstallation`
  Returns:
    the structure for the pdbId

### hasNext

    public boolean hasNext()

  Description copied from interface: `PDBInstallation`
  return if the iteration over all structures will return another structure

  Specified by:
    `hasNext` in interface `PDBInstallation`
  Returns:
    true if there is another structure that has not been iterated over yet

### next

    public Structure next()

  Description copied from interface: `PDBInstallation`
  iterate over all structures in this Installation that pass the provided filters and return the next one in the list.

  Specified by:
    `next` in interface `PDBInstallation`
  Returns:
    the next structure